#include "ArithParser.h"

using namespace name::panitz::parser; 
using namespace std;

namespace arith {
int getVal(Number* n){return n->val;}

template <typename t>
bool eq(t* t1,t* t2){return t1->eq(t2);}

CAF<Parser<int,Token>*> numberP
 = caf((Parser<Number*,Token>*)getToken(&numTok,eq)) << getVal;

Parser<Operator*,Token>* getOp(Operator* op){
  return (Parser<Operator*,Token>*)getToken(op,eq);}

CAF<Parser<Operator*,Token>*> addP = caf(getOp(&addTok));
CAF<Parser<Operator*,Token>*> mulP = caf(getOp(&mulTok));
CAF<Parser<Operator*,Token>*> subP = caf(getOp(&subTok));
CAF<Parser<Operator*,Token>*> divP = caf(getOp(&divTok));

CAF<Parser<Operator*,Token>*>  addOpP = addP || subP;
CAF<Parser<Operator*,Token>*>  mulOpP = mulP || divP;

int calculate(Pair<Pair<int,Operator*>*,int>* pp){
  int i2 = pp->snd;
  Pair<int,Operator*>* p = pp->fst;
  Operator* op= p->snd;
  int i1=p->fst;  
  delete p;
  delete pp;
  return op->op(i1,i2);
}

ArithParser getMultExpr(); 
CAF<ArithParser> multExpr=caf(getMultExpr);

ArithParser getMultExpr(){
  return
    ( (numberP,mulOpP,multExpr) << calculate
    || numberP
    )();
}

ArithParser getAddExpr();
CAF<ArithParser> addExpr=caf(getAddExpr); 
ArithParser getAddExpr(){
  return
    ( (multExpr,addOpP,addExpr) << calculate
    || multExpr
    )();
}

}//end namespace


