#ifndef __ARITHTOKEN_H
#define __ARITHTOKEN_H ;

#include "../name/panitz/util/Show.h"
using namespace name::panitz::util;
namespace arith {

class Token{
 public:
  string name;
  Token::Token(string name);
  virtual bool Token::eq(Token* t);
  virtual bool Token::isNumber();
  virtual bool isOperator();
  virtual string Token::toString();
};

class Number:public Token{
 public:
  int val;
  Number(int val);
  virtual bool isNumber();
  virtual bool eq(Token* t);
  virtual string toString();
};

class Operator:public Token{
  public:
    int(*op)(int,int);
    Operator(string n,int(*op)(int,int));
    virtual bool eq(Token* t);
    virtual bool isOperator();
};

int addOp(int x,int y);
int mulOp(int x,int y);
int subOp(int x,int y);
int divOp(int x,int y);

static Operator addTok = Operator("+",addOp);
static Operator mulTok = Operator("*",mulOp);
static Operator subTok = Operator("-",subOp);
static Operator divTok = Operator("/",divOp);
static Number numTok = Number(42);
}
#endif


