#ifndef __FAB4MKFUNCTIONS_H
#define __FAB4MKFUNCTIONS_H

#include "../name/panitz/parser/ParsLib.h"
#include "Fab4.h"
#include "Fab4Lexer.h"

using namespace name::panitz::parser;
using namespace std;

namespace fab4 {

typedef CAF<Parser<Expr*,Token>*>          PExpr;

typedef 
  Pair<Pair<Pair<Token*,vector<Token*>*>*,Token*>*,Expr*>* 
  caseAltResult;

typedef
  Pair<Pair<Pair<Token*,Expr*>*,Token*>*,vector<CaseAlt*>*>* 
  caseParsResult;

typedef  Either<ConstrDef*,FunDef*> ConstrOrFun;

template <typename a, typename b>
a fst(Pair<a,b>* p){a result = p->fst;delete p;return result;}

template <typename a, typename b>
b snd(Pair<a,b>* p){b result = p->snd;delete p;return result;}

Parser<Token*,Token>*    pTok(Token* t);
Parser<Operator*,Token>* pOp(Token* t);
Parser<Number*,Token>*   pNum(Token* t);

Expr* mkNumExpr(Number* num);
Expr* mkCharExpr(CharLiteral* cl);
Expr* mkStringExpr(StringLiteral* sl);
Expr* mkVar(Token* t);
Expr* mkOpExpr(Pair<Expr*,vector<Pair<Operator*,Expr*>*>*>* p);
Expr* mkFunApps(vector<Expr*>* exprs);
Expr* mkConstr(Pair<Token*,vector<Expr*>*>* p);
CaseAlt* mkCaseAlt(caseAltResult caseAlt);
Expr* mkCaseExpr(caseParsResult casePars);
FunDef* mkFunDef
 (Pair<Pair<Pair<Token*,vector<Token*>*>*,Operator*>*,Expr*>* p);
ConstrDef* mkConstr(Pair<Token*,Number*>* p);
Fab4* mkFab4(vector<ConstrOrFun*>* constrOrFuns);

}
#endif


