#include <string>
#include "../name/panitz/util/Show.h"
#include "Fab4Token.h"

using namespace std;
using namespace name::panitz::util;

namespace fab4 {

Token::Token(string name):name(name){};
 bool Token::eq(Token* t){
   return name==t->name;
}

bool Token::isCName(){return false;}
bool Token::isName(){return false;}
bool Token::isNumber(){return false;}
bool Token::isStringLiteral(){return false;}
bool Token::isCharLiteral(){return false;}
bool Token::isOperator(){return false;}

string Token::toString(){return name;}

CName::CName(string name):Token(name){};
 bool CName::eq(Token* t){
  return t->isCName();
}

 bool CName::isCName(){return true;}
 string CName::toString(){return name;}


Name::Name(string name):Token(name){};
 bool Name::eq(Token* t){
  return t->isName();
}

bool Name::isName(){return true;}
string Name::toString(){return name;}

Number::Number(int val):Token("Number"),val(val){};
bool Number::eq(Token* t){
  return t->isNumber();
}
bool Number::isNumber(){return true;}
string Number::toString(){return show(val);}

StringLiteral::StringLiteral(string str):Token(str){};
bool StringLiteral::isStringLiteral(){return true;}
bool StringLiteral::eq(Token* t){
  return t->isStringLiteral();
}

CharLiteral::CharLiteral(char c):Token("CharLiteral"){this->c=c;};
bool CharLiteral::isCharLiteral(){return true;}
bool CharLiteral::eq(Token* t){
  return t->isCharLiteral();
}

bool Operator::isOperator(){return true;}
string Operator::toString(){return op;}
Operator::Operator(string op):Token(op){this->op=op;}

bool tokenEq(Token* x,Token* y){return x->eq(y);}

vector<Token*> tokenize(char* fileName);
}


