package name.panitz.gm;
import java.io.*;
import java.lang.reflect.Method;
import static name.panitz.gm.MarshallingNode.*;

public class JavaCall implements Instruction{
  public GmState process(GmState st) throws Exception{
    Node n=st.heap.getNode(st.stack.pop());
    int arity=0;
    if (n instanceof NChar)arity=(int)((NChar)n).c;
    else arity=((NNum)n).n;

    Writer originalWriter = st.output;
    st.output=new StringWriter();
    st=new PrintString().process(st);

    String methodName = st.output.toString();

    Object dies = st.heap.get(st.stack.pop())
                         .visit(new MarshallingNode(st));

    st.stack.pop();
    st.stack.pop();
    st.stack.pop();
    st.stack.pop();

    GmStack newArgs = new GmStack();
    for (int i=0;i<arity;i++){
      int a = st.stack.pop();
      newArgs.add(0,((NAp)st.heap.getNode(a)).n2);
    }      

    st.stack.addAll(newArgs);
    Object [] javaArgs = new Object[arity];
    for (int i=0;i<arity;i++){
      WHNF.whnf(st);
      javaArgs[i]=st.heap.getNode(st.stack.pop())
                  .visit(new MarshallingNode(st));
    }

    st.output=originalWriter;

    Class klasse = dies.getClass();
    Class[] argType = new Class[arity];
    for (int i=0;i<arity;i++)argType[i]=javaArgs[i].getClass();
    Method m = klasse.getMethod(methodName,argType);

    final Object o=m.invoke(dies,javaArgs);
    final int neededSpace= MarshallingNode.neededHeapSpace(o);
    st.gc.check(neededSpace);

    int adr=demarshalling(o,st);
    st.stack.push(adr);

    return st;
  }
  public String toString(){return "JavaCall";}
}

