package name.panitz.gm;

public class PrintNode implements NodeVisitor<GmState>{
  GmState st;
  public PrintNode(GmState st){this.st=st;}

  public GmState eval(NNum n)throws Exception{
    st.output.write(""+n.n);
    st.output.flush();
    st.stack.pop();

    return st;
  }
  public GmState eval(NChar n)throws Exception{
    st.output.write("'"+n.c+"'");
    st.output.flush();
    st.stack.pop();

    return st;
  }
  public GmState eval(NJavaObject n)throws Exception{
    st.output.write(""+n.o);
    st.stack.pop();

    return st;
  }

  public GmState eval(NConstr constr)throws Exception{
    st.output.write("("+st.constructors[constr.name]);
    st.output.flush();
    st.stack.pop();

    for (Integer a:constr.args) {

      st.stack.push(a);
      WHNF.whnf(st);
      st=new Output(" ").process(st);
      st=new Print().process(st);
    }

      st=new Output(")").process(st);
    st.output.flush();
    return st;
  }

  public GmState eval(NInd n) throws Exception{
    st.stack.push(n.adr);
    return st.heap.get(n.adr).visit(this);
  }

  public GmState eval(NAp n)throws Exception{
    st.stack.pop();
    st.output.flush();
    return st;
  }

  public GmState eval(NGlobal n)throws Exception{
    st.stack.pop();
    st.output.flush();
    return st;
  }

  public GmState eval(Node n)throws Exception{
    throw new Exception("unmatched pattern: "+n);
  }
}

