package name.panitz.gm;
import java.io.*;

public class StaticJavaCall implements Instruction{
  public GmState process(GmState st) throws Exception{
    Node n=st.heap.getNode(st.stack.pop());
    int arity=0;
    if (n instanceof NChar)arity=(int)((NChar)n).c;
    else arity=((NNum)n).n;

    Writer originalWriter = st.output;
    st.output=new StringWriter();
    st=new PrintString().process(st);
    st.stack.pop();
    st.stack.pop();
    st.stack.pop();

    String methodName = st.output.toString();

    GmStack newArgs = new GmStack();
    for (int i=0;i<arity;i++){
      int a = st.stack.pop();
      newArgs.add(0,((NAp)st.heap.getNode(a)).n2);
    }      
    st.stack.addAll(newArgs);
    Object [] javaArgs = new Object[arity];
    for (int i=0;i<arity;i++){
      WHNF.whnf(st);
      javaArgs[i]=st.heap.getNode(st.stack.pop())
                     .visit(new MarshallingNode(st));
    }

    st.output=originalWriter;
    String className
      = methodName.substring(0,methodName.lastIndexOf('.'));
    String mName
      = methodName.substring(methodName.lastIndexOf('.')+1);

    Class klasse = Class.forName(className);
    Class[] argType = new Class[arity];
    for (int i=0;i<arity;i++)argType[i]=javaArgs[i].getClass();
    java.lang.reflect.Method m = klasse.getMethod(mName,argType);

    final Object o=m.invoke(null,javaArgs);
    final int neededSpace= MarshallingNode.neededHeapSpace(o);
    st.gc.check(neededSpace);
    st.stack.push(
       MarshallingNode.demarshalling(o,st));
    return st;
  }
  public String toString(){return "StaticJavaCall";}
}

