package name.panitz.gm;
import name.panitz.util.Pair;

public class UnwindNode implements NodeVisitor<GmState>{
  GmState st;
  public UnwindNode(GmState st){this.st=st;}

  public GmState eval(NNum n){return evalConstant(n);}
  public GmState eval(NChar n){return evalConstant(n);}
  public GmState eval(NConstr n){return evalConstant(n);}
  public GmState eval(NJavaObject n){
    return evalConstant(n);
  }

  private GmState  evalConstant(Node n){
   if (st.dump.size()>0){
      Pair<Integer,GmStack> d=st.dump.get(0);
      st.dump.remove(0);
      d.e2.push(st.stack.pop());
      st.stack=d.e2;
      st.pc=d.e1; 
    }
    return st;
  }

  public GmState eval(NInd n)throws Exception{
    st.stack.pop();
    st.stack.push(n.adr);
    return st.heap.get(n.adr).visit(this);}

  public GmState eval(NAp n)throws Exception{
    st.stack.push(n.n1);
    return st.heap.get(n.n1).visit(this);}

  public GmState eval(NGlobal n){
    if (st.stack.size()<=n.argc)
      throw new RuntimeException
         ("Unwinding to few Arguments to "+n+" in function: "
          +st.getCurrentFunction()
          +"\n found "+st.stack.size()
          + " required: "+n.argc+" arguments");

    st.stack.pop();
    GmStack newArgs = new GmStack();
    for (int i=0;i<n.argc;i++){
      int a = i==n.argc-1?st.stack.peek(0):st.stack.pop();
      newArgs.add(0,((NAp)st.heap.get(a)).n2);
    }
    st.stack.addAll(newArgs);
    st.pc=n.i;
    return st;
  }

  public GmState eval(Node n)throws Exception{
    throw new Exception("unmatched pattern: "+n);
  }
}

